/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/s390/s390.md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "emit-rtl.h"
#include "tm-constrs.h"
#include "target.h"

int
const0_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      break;
    default:
      return false;
    }
  return (
#line 30 "../../gcc/config/s390/predicates.md"
(op == CONST0_RTX (mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

int
all_ones_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_VECTOR:
      break;
    default:
      return false;
    }
  return ((
#line 35 "../../gcc/config/s390/predicates.md"
(INTEGRAL_MODE_P (GET_MODE (op)))) && (
#line 36 "../../gcc/config/s390/predicates.md"
(op == CONSTM1_RTX (mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

int
const_mask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 41 "../../gcc/config/s390/predicates.md"
(UINTVAL (op) < 16));
}

int
consttable_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case LABEL_REF:
    case CONST:
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      break;
    default:
      return false;
    }
  return 
#line 47 "../../gcc/config/s390/predicates.md"
(CONSTANT_P (op));
}

int
permute_pattern_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_VECTOR:
    case MEM:
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
#line 56 "../../gcc/config/s390/predicates.md"
(GET_MODE (op) == V16QImode)) && (
#line 57 "../../gcc/config/s390/predicates.md"
(!MEM_P (op) || s390_mem_constraint ("R", op)));
}

static inline int
s_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 64 "../../gcc/config/s390/predicates.md"
{
  /* Just like memory_operand, allow (subreg (mem ...))
     after reload.  */
  if (reload_completed
      && GET_CODE (op) == SUBREG
      && GET_CODE (SUBREG_REG (op)) == MEM)
    op = SUBREG_REG (op);

  if (GET_CODE (op) != MEM)
    return false;
  if (!s390_legitimate_address_without_index_p (op))
    return false;

  return true;
}

int
s_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SUBREG || GET_CODE (op) == MEM) && (general_operand (op, mode))) && (
(s_operand_1 (op, mode)));
}

static inline int
plus16_Q_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 86 "../../gcc/config/s390/predicates.md"
{
  rtx addr = XEXP (op, 0);
  if (REG_P (addr))
    return true;

  if (GET_CODE (addr) != PLUS
      || !REG_P (XEXP (addr, 0))
      || !CONST_INT_P (XEXP (addr, 1)))
    return false;

  return SHORT_DISP_IN_RANGE (INTVAL (XEXP (addr, 1)) + 16);
}

int
plus16_Q_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (general_operand (op, mode))) && (
(plus16_Q_operand_1 (op, mode)));
}

int
bras_sym_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (
#line 104 "../../gcc/config/s390/predicates.md"
(!flag_pic || SYMBOL_REF_LOCAL_P (op)))) || ((GET_CODE (op) == CONST) && ((
#line 106 "../../gcc/config/s390/predicates.md"
(GET_CODE (XEXP (op, 0)) == UNSPEC)) && (
#line 107 "../../gcc/config/s390/predicates.md"
(XINT (XEXP (op, 0), 1) == UNSPEC_PLT))));
}

int
s390_plus_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PLUS) && ((
#line 114 "../../gcc/config/s390/predicates.md"
(mode == Pmode)) && (
#line 115 "../../gcc/config/s390/predicates.md"
(!legitimate_la_operand_p (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
setmem_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 121 "../../gcc/config/s390/predicates.md"
{
  HOST_WIDE_INT offset;
  rtx base;

  if (GET_MODE (op) != VOIDmode
      && GET_MODE_CLASS (GET_MODE (op)) != MODE_INT)
    return false;

  /* Extract base register and offset.  */
  if (!s390_decompose_addrstyle_without_index (op, &base, &offset))
    return false;

  /* Don't allow any non-base hard registers.  Doing so without
     confusing reload and/or regrename would be tricky, and doesn't
     buy us much anyway.  */
  if (base && REGNO (base) < FIRST_PSEUDO_REGISTER && !ADDR_REG_P (base))
    return false;

  /* Unfortunately we have to reject constants that are invalid
     for an address, or else reload will get confused.  */
  if (!DISP_IN_RANGE (offset))
    return false;

  return true;
}

int
setmem_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
    case PLUS:
    case CONST_INT:
      break;
    default:
      return false;
    }
  return (
(setmem_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

int
const_int_6bitset_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 150 "../../gcc/config/s390/predicates.md"
((INTVAL (op) & 63) == 63));
}

int
nonzero_shift_count_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 153 "../../gcc/config/s390/predicates.md"
(IN_RANGE (INTVAL (op), 1, GET_MODE_BITSIZE (mode) - 1)));
}

static inline int
larl_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 159 "../../gcc/config/s390/predicates.md"
{
  /* Allow labels and local symbols.  */
  if (GET_CODE (op) == LABEL_REF)
    return true;
  if (SYMBOL_REF_P (op))
    return (!SYMBOL_FLAG_NOTALIGN2_P (op)
	    && SYMBOL_REF_TLS_MODEL (op) == 0
	    && s390_rel_address_ok_p (op));

  /* Everything else must have a CONST, so strip it.  */
  if (GET_CODE (op) != CONST)
    return false;
  op = XEXP (op, 0);

  /* Allow adding *even* in-range constants.  */
  if (GET_CODE (op) == PLUS)
    {
      if (GET_CODE (XEXP (op, 1)) != CONST_INT
          || (INTVAL (XEXP (op, 1)) & 1) != 0)
        return false;
      if (INTVAL (XEXP (op, 1)) >= HOST_WIDE_INT_1 << 31
	  || INTVAL (XEXP (op, 1)) < -(HOST_WIDE_INT_1 << 31))
        return false;
      op = XEXP (op, 0);
    }

  /* Labels and local symbols allowed here as well.  */
  if (GET_CODE (op) == LABEL_REF)
    return true;
  if (SYMBOL_REF_P (op))
    return (!SYMBOL_FLAG_NOTALIGN2_P (op)
	    && SYMBOL_REF_TLS_MODEL (op) == 0
	    && s390_rel_address_ok_p (op));


  /* Now we must have a @GOTENT offset or @PLT stub
     or an @INDNTPOFF TLS offset.  */
  if (GET_CODE (op) == UNSPEC
      && XINT (op, 1) == UNSPEC_GOTENT)
    return true;
  if (GET_CODE (op) == UNSPEC
      && XINT (op, 1) == UNSPEC_PLT)
    return true;
  if (GET_CODE (op) == UNSPEC
      && XINT (op, 1) == UNSPEC_INDNTPOFF)
    return true;

  return false;
}

int
larl_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LABEL_REF:
    case SYMBOL_REF:
    case CONST:
      break;
    default:
      return false;
    }
  return (
(larl_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

static inline int
contiguous_bitmask_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 212 "../../gcc/config/s390/predicates.md"
{
  return s390_contiguous_bitmask_p (INTVAL (op), true,
                                    GET_MODE_BITSIZE (mode), NULL, NULL);
}

int
contiguous_bitmask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
(contiguous_bitmask_operand_1 (op, mode)));
}

static inline int
contiguous_bitmask_nowrap_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 220 "../../gcc/config/s390/predicates.md"
{
  return s390_contiguous_bitmask_p
    (INTVAL (op), false, GET_MODE_BITSIZE (mode), NULL, NULL);
}

int
contiguous_bitmask_nowrap_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
(contiguous_bitmask_nowrap_operand_1 (op, mode)));
}

int
loc_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (nonimmediate_operand (op, mode)) || (((GET_CODE (op) == CONST_INT) && (
#line 230 "../../gcc/config/s390/predicates.md"
(INTVAL (op) <= 32767 && INTVAL (op) >= -32768))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode)));
}

int
reload_const_wide_int_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_WIDE_INT) && (
#line 234 "../../gcc/config/s390/predicates.md"
(legitimate_reload_constant_p (op)));
}

static inline int
s390_comparison_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 246 "../../gcc/config/s390/predicates.md"
{
  if (GET_CODE (XEXP (op, 0)) != REG
      || REGNO (XEXP (op, 0)) != CC_REGNUM
      || (XEXP (op, 1) != const0_rtx
          && !(CONST_INT_P (XEXP (op, 1))
	       && GET_MODE (XEXP (op, 0)) == CCRAWmode
	       && INTVAL (XEXP (op, 1)) >= 0
               && INTVAL (XEXP (op, 1)) <= 15)))
    return false;

  return (s390_branch_condition_mask (op) >= 0);
}

int
s390_comparison (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
    case LT:
    case GT:
    case LE:
    case GE:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
    case UNEQ:
    case UNLT:
    case UNGT:
    case UNLE:
    case UNGE:
    case LTGT:
    case UNORDERED:
    case ORDERED:
      break;
    default:
      return false;
    }
  return (
(s390_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
cc_reg_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 262 "../../gcc/config/s390/predicates.md"
(REGNO (op) == CC_REGNUM))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
s390_signed_integer_comparison_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 266 "../../gcc/config/s390/predicates.md"
{
  return (s390_compare_and_branch_condition_mask (op) >= 0);
}

int
s390_signed_integer_comparison (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
    case LT:
    case GT:
    case LE:
    case GE:
      break;
    default:
      return false;
    }
  return (
(s390_signed_integer_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
s390_unsigned_integer_comparison_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 272 "../../gcc/config/s390/predicates.md"
{
  return (s390_compare_and_branch_condition_mask (op) >= 0);
}

int
s390_unsigned_integer_comparison (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
      break;
    default:
      return false;
    }
  return (
(s390_unsigned_integer_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
s390_eqne_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
s390_scond_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LTU:
    case GTU:
    case LEU:
    case GEU:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
s390_brx_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LE:
    case GT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

static inline int
s390_alc_comparison_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 292 "../../gcc/config/s390/predicates.md"
{
  while (GET_CODE (op) == ZERO_EXTEND || GET_CODE (op) == SIGN_EXTEND)
    op = XEXP (op, 0);

  if (!COMPARISON_P (op))
    return false;

  if (GET_CODE (XEXP (op, 0)) != REG
      || REGNO (XEXP (op, 0)) != CC_REGNUM
      || (XEXP (op, 1) != const0_rtx
          && !(CONST_INT_P (XEXP (op, 1))
	       && GET_MODE (XEXP (op, 0)) == CCRAWmode
	       && INTVAL (XEXP (op, 1)) >= 0
               && INTVAL (XEXP (op, 1)) <= 15)))
    return false;

  switch (GET_MODE (XEXP (op, 0)))
    {
    case E_CCL1mode:
      return GET_CODE (op) == LTU;

    case E_CCL2mode:
      return GET_CODE (op) == LEU;

    case E_CCL3mode:
      return GET_CODE (op) == GEU;

    case E_CCUmode:
      return GET_CODE (op) == GTU;

    case E_CCURmode:
      return GET_CODE (op) == LTU;

    case E_CCSmode:
      return GET_CODE (op) == UNGT;

    case E_CCSRmode:
      return GET_CODE (op) == UNLT;

    default:
      return false;
    }
}

int
s390_alc_comparison (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case ZERO_EXTEND:
    case SIGN_EXTEND:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
      break;
    default:
      return false;
    }
  return (
(s390_alc_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
s390_slb_comparison_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 341 "../../gcc/config/s390/predicates.md"
{
  while (GET_CODE (op) == ZERO_EXTEND || GET_CODE (op) == SIGN_EXTEND)
    op = XEXP (op, 0);

  if (!COMPARISON_P (op))
    return false;

  if (GET_CODE (XEXP (op, 0)) != REG
      || REGNO (XEXP (op, 0)) != CC_REGNUM
      || XEXP (op, 1) != const0_rtx)
    return false;

  switch (GET_MODE (XEXP (op, 0)))
    {
    case E_CCL1mode:
      return GET_CODE (op) == GEU;

    case E_CCL2mode:
      return GET_CODE (op) == GTU;

    case E_CCL3mode:
      return GET_CODE (op) == LTU;

    case E_CCUmode:
      return GET_CODE (op) == LEU;

    case E_CCURmode:
      return GET_CODE (op) == GEU;

    case E_CCSmode:
      return GET_CODE (op) == LE;

    case E_CCSRmode:
      return GET_CODE (op) == GE;

    default:
      return false;
    }
}

int
s390_slb_comparison (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case ZERO_EXTEND:
    case SIGN_EXTEND:
    case LTU:
    case GTU:
    case LEU:
    case GEU:
      break;
    default:
      return false;
    }
  return (
(s390_slb_comparison_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
load_multiple_operation_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 386 "../../gcc/config/s390/predicates.md"
{
  machine_mode elt_mode;
  int count = XVECLEN (op, 0);
  unsigned int dest_regno;
  rtx src_addr;
  int i, off;

  /* Perform a quick check so we don't blow up below.  */
  if (count <= 1
      || GET_CODE (XVECEXP (op, 0, 0)) != SET
      || GET_CODE (SET_DEST (XVECEXP (op, 0, 0))) != REG
      || GET_CODE (SET_SRC (XVECEXP (op, 0, 0))) != MEM)
    return false;

  dest_regno = REGNO (SET_DEST (XVECEXP (op, 0, 0)));
  src_addr = XEXP (SET_SRC (XVECEXP (op, 0, 0)), 0);
  elt_mode = GET_MODE (SET_DEST (XVECEXP (op, 0, 0)));

  /* Check, is base, or base + displacement.  */

  if (GET_CODE (src_addr) == REG)
    off = 0;
  else if (GET_CODE (src_addr) == PLUS
	   && GET_CODE (XEXP (src_addr, 0)) == REG
	   && GET_CODE (XEXP (src_addr, 1)) == CONST_INT)
    {
      off = INTVAL (XEXP (src_addr, 1));
      src_addr = XEXP (src_addr, 0);
    }
  else
    return false;

  for (i = 1; i < count; i++)
    {
      rtx elt = XVECEXP (op, 0, i);

      if (GET_CODE (elt) != SET
	  || GET_CODE (SET_DEST (elt)) != REG
	  || GET_MODE (SET_DEST (elt)) != elt_mode
	  || REGNO (SET_DEST (elt)) != dest_regno + i
	  || GET_CODE (SET_SRC (elt)) != MEM
	  || GET_MODE (SET_SRC (elt)) != elt_mode
	  || GET_CODE (XEXP (SET_SRC (elt), 0)) != PLUS
	  || ! rtx_equal_p (XEXP (XEXP (SET_SRC (elt), 0), 0), src_addr)
	  || GET_CODE (XEXP (XEXP (SET_SRC (elt), 0), 1)) != CONST_INT
	  || INTVAL (XEXP (XEXP (SET_SRC (elt), 0), 1))
	     != off + i * GET_MODE_SIZE (elt_mode))
	return false;
    }

  return true;
}

int
load_multiple_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(load_multiple_operation_1 (op, mode)));
}

static inline int
execute_operation_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 445 "../../gcc/config/s390/predicates.md"
{
  rtx pattern = op;
  rtx_insn *insn;
  int icode;

  /* This is redundant but since this predicate is evaluated
     first when recognizing the insn we can prevent the more
     expensive code below from being executed for many cases.  */
  if (GET_CODE (XVECEXP (pattern, 0, 0)) != UNSPEC
      || XINT (XVECEXP (pattern, 0, 0), 1) != UNSPEC_EXECUTE)
    return false;

  /* Keep in sync with s390_execute_target.  */
  if (XVECLEN (pattern, 0) == 2)
    {
      pattern = copy_rtx (XVECEXP (pattern, 0, 1));
    }
  else
    {
      rtvec vec = rtvec_alloc (XVECLEN (pattern, 0) - 1);
      int i;

      for (i = 0; i < XVECLEN (pattern, 0) - 1; i++)
	RTVEC_ELT (vec, i) = copy_rtx (XVECEXP (pattern, 0, i + 1));

      pattern = gen_rtx_PARALLEL (VOIDmode, vec);
    }

  /* Since we do not have the wrapping insn here we have to build one.  */
  insn = make_insn_raw (pattern);
  icode = recog_memoized (insn);
  if (icode < 0)
    return false;

  extract_constrain_insn (insn);

  return which_alternative >= 0;
}

int
execute_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(execute_operation_1 (op, mode)));
}

static inline int
store_multiple_operation_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 489 "../../gcc/config/s390/predicates.md"
{
  machine_mode elt_mode;
  int count = XVECLEN (op, 0);
  unsigned int src_regno;
  rtx dest_addr;
  int i, off;

  /* Perform a quick check so we don't blow up below.  */
  if (count <= 1
      || GET_CODE (XVECEXP (op, 0, 0)) != SET
      || GET_CODE (SET_DEST (XVECEXP (op, 0, 0))) != MEM
      || GET_CODE (SET_SRC (XVECEXP (op, 0, 0))) != REG)
    return false;

  src_regno = REGNO (SET_SRC (XVECEXP (op, 0, 0)));
  dest_addr = XEXP (SET_DEST (XVECEXP (op, 0, 0)), 0);
  elt_mode = GET_MODE (SET_SRC (XVECEXP (op, 0, 0)));

  /* Check, is base, or base + displacement.  */

  if (GET_CODE (dest_addr) == REG)
    off = 0;
  else if (GET_CODE (dest_addr) == PLUS
	   && GET_CODE (XEXP (dest_addr, 0)) == REG
	   && GET_CODE (XEXP (dest_addr, 1)) == CONST_INT)
    {
      off = INTVAL (XEXP (dest_addr, 1));
      dest_addr = XEXP (dest_addr, 0);
    }
  else
    return false;

  for (i = 1; i < count; i++)
    {
      rtx elt = XVECEXP (op, 0, i);

      if (GET_CODE (elt) != SET
	  || GET_CODE (SET_SRC (elt)) != REG
	  || GET_MODE (SET_SRC (elt)) != elt_mode
	  || REGNO (SET_SRC (elt)) != src_regno + i
	  || GET_CODE (SET_DEST (elt)) != MEM
	  || GET_MODE (SET_DEST (elt)) != elt_mode
	  || GET_CODE (XEXP (SET_DEST (elt), 0)) != PLUS
	  || ! rtx_equal_p (XEXP (XEXP (SET_DEST (elt), 0), 0), dest_addr)
	  || GET_CODE (XEXP (XEXP (SET_DEST (elt), 0), 1)) != CONST_INT
	  || INTVAL (XEXP (XEXP (SET_DEST (elt), 0), 1))
	     != off + i * GET_MODE_SIZE (elt_mode))
	return false;
    }
  return true;
}

int
store_multiple_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(store_multiple_operation_1 (op, mode)));
}

static inline int
const_shift_by_byte_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 543 "../../gcc/config/s390/predicates.md"
{
  unsigned HOST_WIDE_INT val = INTVAL (op);
  return val <= 128 && val % 8 == 0;
}

int
const_shift_by_byte_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
(const_shift_by_byte_operand_1 (op, mode)));
}

static inline int
nonsym_memory_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 556 "../../gcc/config/s390/predicates.md"
{
  return memory_operand (op, mode) && !contains_symbol_ref_p (op);
}

int
nonsym_memory_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(nonsym_memory_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

enum constraint_num
lookup_constraint_1 (const char *str)
{
  switch (str[0])
    {
    case '<':
      return CONSTRAINT__l;
    case '>':
      return CONSTRAINT__g;
    case 'A':
      if (!strncmp (str + 1, "R", 1))
        return CONSTRAINT_AR;
      if (!strncmp (str + 1, "S", 1))
        return CONSTRAINT_AS;
      if (!strncmp (str + 1, "T", 1))
        return CONSTRAINT_AT;
      if (!strncmp (str + 1, "Q", 1))
        return CONSTRAINT_AQ;
      break;
    case 'B':
      if (!strncmp (str + 1, "R", 1))
        return CONSTRAINT_BR;
      if (!strncmp (str + 1, "S", 1))
        return CONSTRAINT_BS;
      if (!strncmp (str + 1, "T", 1))
        return CONSTRAINT_BT;
      if (!strncmp (str + 1, "Q", 1))
        return CONSTRAINT_BQ;
      break;
    case 'C':
      return CONSTRAINT_C;
    case 'D':
      return CONSTRAINT_D;
    case 'E':
      return CONSTRAINT_E;
    case 'F':
      return CONSTRAINT_F;
    case 'G':
      return CONSTRAINT_G;
    case 'I':
      return CONSTRAINT_I;
    case 'J':
      return CONSTRAINT_J;
    case 'K':
      return CONSTRAINT_K;
    case 'L':
      return CONSTRAINT_L;
    case 'M':
      return CONSTRAINT_M;
    case 'N':
      if (!strncmp (str + 1, "xHD0", 4))
        return CONSTRAINT_NxHD0;
      if (!strncmp (str + 1, "xSD0", 4))
        return CONSTRAINT_NxSD0;
      if (!strncmp (str + 1, "xQD0", 4))
        return CONSTRAINT_NxQD0;
      if (!strncmp (str + 1, "3HD0", 4))
        return CONSTRAINT_N3HD0;
      if (!strncmp (str + 1, "2HD0", 4))
        return CONSTRAINT_N2HD0;
      if (!strncmp (str + 1, "1SD0", 4))
        return CONSTRAINT_N1SD0;
      if (!strncmp (str + 1, "1HS0", 4))
        return CONSTRAINT_N1HS0;
      if (!strncmp (str + 1, "1HD0", 4))
        return CONSTRAINT_N1HD0;
      if (!strncmp (str + 1, "0SD0", 4))
        return CONSTRAINT_N0SD0;
      if (!strncmp (str + 1, "0HS0", 4))
        return CONSTRAINT_N0HS0;
      if (!strncmp (str + 1, "0HD0", 4))
        return CONSTRAINT_N0HD0;
      if (!strncmp (str + 1, "xQDF", 4))
        return CONSTRAINT_NxQDF;
      if (!strncmp (str + 1, "1SDF", 4))
        return CONSTRAINT_N1SDF;
      if (!strncmp (str + 1, "0SDF", 4))
        return CONSTRAINT_N0SDF;
      if (!strncmp (str + 1, "3HDF", 4))
        return CONSTRAINT_N3HDF;
      if (!strncmp (str + 1, "2HDF", 4))
        return CONSTRAINT_N2HDF;
      if (!strncmp (str + 1, "1HDF", 4))
        return CONSTRAINT_N1HDF;
      if (!strncmp (str + 1, "0HDF", 4))
        return CONSTRAINT_N0HDF;
      if (!strncmp (str + 1, "0HSF", 4))
        return CONSTRAINT_N0HSF;
      if (!strncmp (str + 1, "1HSF", 4))
        return CONSTRAINT_N1HSF;
      if (!strncmp (str + 1, "xQSF", 4))
        return CONSTRAINT_NxQSF;
      if (!strncmp (str + 1, "xQHF", 4))
        return CONSTRAINT_NxQHF;
      if (!strncmp (str + 1, "xQH0", 4))
        return CONSTRAINT_NxQH0;
      if (!strncmp (str + 1, "xxDw", 4))
        return CONSTRAINT_NxxDw;
      if (!strncmp (str + 1, "xxSq", 4))
        return CONSTRAINT_NxxSq;
      if (!strncmp (str + 1, "xxSw", 4))
        return CONSTRAINT_NxxSw;
      if (!strncmp (str + 1, "xQS0", 4))
        return CONSTRAINT_NxQS0;
      break;
    case 'O':
      if (!strncmp (str + 1, "p", 1))
        return CONSTRAINT_Op;
      if (!strncmp (str + 1, "n", 1))
        return CONSTRAINT_On;
      if (!strncmp (str + 1, "s", 1))
        return CONSTRAINT_Os;
      break;
    case 'P':
      return CONSTRAINT_P;
    case 'Q':
      return CONSTRAINT_Q;
    case 'R':
      return CONSTRAINT_R;
    case 'S':
      return CONSTRAINT_S;
    case 'T':
      return CONSTRAINT_T;
    case 'U':
      return CONSTRAINT_U;
    case 'V':
      return CONSTRAINT_V;
    case 'W':
      return CONSTRAINT_W;
    case 'X':
      return CONSTRAINT_X;
    case 'Y':
      return CONSTRAINT_Y;
    case 'Z':
      if (!strncmp (str + 1, "R", 1))
        return CONSTRAINT_ZR;
      if (!strncmp (str + 1, "S", 1))
        return CONSTRAINT_ZS;
      if (!strncmp (str + 1, "T", 1))
        return CONSTRAINT_ZT;
      if (!strncmp (str + 1, "L", 1))
        return CONSTRAINT_ZL;
      if (!strncmp (str + 1, "Q", 1))
        return CONSTRAINT_ZQ;
      break;
    case 'a':
      return CONSTRAINT_a;
    case 'b':
      return CONSTRAINT_b;
    case 'c':
      return CONSTRAINT_c;
    case 'd':
      return CONSTRAINT_d;
    case 'e':
      return CONSTRAINT_e;
    case 'f':
      return CONSTRAINT_f;
    case 'i':
      return CONSTRAINT_i;
    case 'j':
      if (!strncmp (str + 1, "m1", 2))
        return CONSTRAINT_jm1;
      if (!strncmp (str + 1, "xx", 2))
        return CONSTRAINT_jxx;
      if (!strncmp (str + 1, "yy", 2))
        return CONSTRAINT_jyy;
      if (!strncmp (str + 1, "KK", 2))
        return CONSTRAINT_jKK;
      if (!strncmp (str + 1, "m6", 2))
        return CONSTRAINT_jm6;
      if (!strncmp (str + 1, "dd", 2))
        return CONSTRAINT_jdd;
      if (!strncmp (str + 1, "00", 2))
        return CONSTRAINT_j00;
      break;
    case 'm':
      return CONSTRAINT_m;
    case 'n':
      return CONSTRAINT_n;
    case 'o':
      return CONSTRAINT_o;
    case 'p':
      return CONSTRAINT_p;
    case 'r':
      return CONSTRAINT_r;
    case 's':
      return CONSTRAINT_s;
    case 't':
      return CONSTRAINT_t;
    case 'v':
      return CONSTRAINT_v;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

const unsigned char lookup_constraint_array[] = {
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__l, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__g, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  UCHAR_MAX,
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_C, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_D, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_E, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_F, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_G, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_I, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_J, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_K, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_L, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_M, (int) UCHAR_MAX),
  UCHAR_MAX,
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_P, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_Q, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_R, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_S, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_T, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_U, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_V, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_W, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_X, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_Y, (int) UCHAR_MAX),
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_a, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_b, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_c, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_d, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_e, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_f, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_i, (int) UCHAR_MAX),
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_m, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_n, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_o, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_p, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_r, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_s, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_t, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_v, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN
};

enum reg_class
reg_class_for_constraint_1 (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_r: return GENERAL_REGS;
    case CONSTRAINT_a: return ADDR_REGS;
    case CONSTRAINT_c: return CC_REGS;
    case CONSTRAINT_d: return GENERAL_REGS;
    case CONSTRAINT_f: return FP_REGS;
    case CONSTRAINT_t: return ACCESS_REGS;
    case CONSTRAINT_v: return VEC_REGS;
    default: break;
    }
  return NO_REGS;
}

bool (*constraint_satisfied_p_array[]) (rtx) = {
  satisfies_constraint_I,
  satisfies_constraint_J,
  satisfies_constraint_K,
  satisfies_constraint_L,
  satisfies_constraint_M,
  satisfies_constraint_P,
  satisfies_constraint_NxQS0,
  satisfies_constraint_NxHD0,
  satisfies_constraint_NxSD0,
  satisfies_constraint_NxQD0,
  satisfies_constraint_N3HD0,
  satisfies_constraint_N2HD0,
  satisfies_constraint_N1SD0,
  satisfies_constraint_N1HS0,
  satisfies_constraint_N1HD0,
  satisfies_constraint_N0SD0,
  satisfies_constraint_N0HS0,
  satisfies_constraint_N0HD0,
  satisfies_constraint_NxQDF,
  satisfies_constraint_N1SDF,
  satisfies_constraint_N0SDF,
  satisfies_constraint_N3HDF,
  satisfies_constraint_N2HDF,
  satisfies_constraint_N1HDF,
  satisfies_constraint_N0HDF,
  satisfies_constraint_N0HSF,
  satisfies_constraint_N1HSF,
  satisfies_constraint_NxQSF,
  satisfies_constraint_NxQHF,
  satisfies_constraint_NxQH0,
  satisfies_constraint_NxxDw,
  satisfies_constraint_NxxSq,
  satisfies_constraint_NxxSw,
  satisfies_constraint_Os,
  satisfies_constraint_Op,
  satisfies_constraint_On,
  satisfies_constraint_e,
  satisfies_constraint_o,
  satisfies_constraint_Q,
  satisfies_constraint_R,
  satisfies_constraint_S,
  satisfies_constraint_T,
  satisfies_constraint_b,
  satisfies_constraint_m,
  satisfies_constraint_AQ,
  satisfies_constraint_AR,
  satisfies_constraint_AS,
  satisfies_constraint_AT,
  satisfies_constraint_p,
  satisfies_constraint_Y,
  satisfies_constraint_U,
  satisfies_constraint_W,
  satisfies_constraint_ZQ,
  satisfies_constraint_ZR,
  satisfies_constraint_ZS,
  satisfies_constraint_ZT,
  satisfies_constraint_C,
  satisfies_constraint_D,
  satisfies_constraint_G,
  satisfies_constraint_jxx,
  satisfies_constraint_jyy,
  satisfies_constraint_jKK,
  satisfies_constraint_jm6,
  satisfies_constraint_jdd,
  satisfies_constraint_V,
  satisfies_constraint__l,
  satisfies_constraint__g,
  satisfies_constraint_i,
  satisfies_constraint_s,
  satisfies_constraint_n,
  satisfies_constraint_E,
  satisfies_constraint_F,
  satisfies_constraint_X,
  satisfies_constraint_j00,
  satisfies_constraint_jm1,
  satisfies_constraint_BQ,
  satisfies_constraint_BR,
  satisfies_constraint_BS,
  satisfies_constraint_BT,
  satisfies_constraint_ZL
};

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_I:
      return 
#line 160 "../../gcc/config/s390/constraints.md"
((unsigned HOST_WIDE_INT) ival <= 255);

    case CONSTRAINT_J:
      return 
#line 166 "../../gcc/config/s390/constraints.md"
((unsigned HOST_WIDE_INT) ival <= 4095);

    case CONSTRAINT_K:
      return 
#line 172 "../../gcc/config/s390/constraints.md"
(ival >= -32768 && ival <= 32767);

    case CONSTRAINT_L:
      return 
#line 180 "../../gcc/config/s390/constraints.md"
(TARGET_LONG_DISPLACEMENT ?
              (ival >= -524288 && ival <= 524287)
            : (ival >= 0 && ival <= 4095));

    case CONSTRAINT_M:
      return 
#line 188 "../../gcc/config/s390/constraints.md"
(ival == 2147483647);

    case CONSTRAINT_P:
      return 
#line 195 "../../gcc/config/s390/constraints.md"
(legitimate_reload_constant_p (GEN_INT (ival)));

    case CONSTRAINT_NxQS0:
      return 
#line 228 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQS0", ival));

    case CONSTRAINT_NxHD0:
      return 
#line 234 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xHD0", ival));

    case CONSTRAINT_NxSD0:
      return 
#line 240 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xSD0", ival));

    case CONSTRAINT_NxQD0:
      return 
#line 246 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQD0", ival));

    case CONSTRAINT_N3HD0:
      return 
#line 252 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("3HD0", ival));

    case CONSTRAINT_N2HD0:
      return 
#line 258 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("2HD0", ival));

    case CONSTRAINT_N1SD0:
      return 
#line 264 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1SD0", ival));

    case CONSTRAINT_N1HS0:
      return 
#line 270 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HS0", ival));

    case CONSTRAINT_N1HD0:
      return 
#line 276 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HD0", ival));

    case CONSTRAINT_N0SD0:
      return 
#line 282 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0SD0", ival));

    case CONSTRAINT_N0HS0:
      return 
#line 288 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HS0", ival));

    case CONSTRAINT_N0HD0:
      return 
#line 294 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HD0", ival));

    case CONSTRAINT_NxQDF:
      return 
#line 300 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQDF", ival));

    case CONSTRAINT_N1SDF:
      return 
#line 306 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1SDF", ival));

    case CONSTRAINT_N0SDF:
      return 
#line 312 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0SDF", ival));

    case CONSTRAINT_N3HDF:
      return 
#line 318 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("3HDF", ival));

    case CONSTRAINT_N2HDF:
      return 
#line 324 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("2HDF", ival));

    case CONSTRAINT_N1HDF:
      return 
#line 330 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HDF", ival));

    case CONSTRAINT_N0HDF:
      return 
#line 336 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HDF", ival));

    case CONSTRAINT_N0HSF:
      return 
#line 342 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("0HSF", ival));

    case CONSTRAINT_N1HSF:
      return 
#line 348 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("1HSF", ival));

    case CONSTRAINT_NxQSF:
      return 
#line 354 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQSF", ival));

    case CONSTRAINT_NxQHF:
      return 
#line 360 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQHF", ival));

    case CONSTRAINT_NxQH0:
      return 
#line 366 "../../gcc/config/s390/constraints.md"
(s390_N_constraint_str ("xQH0", ival));

    case CONSTRAINT_NxxDw:
      return 
#line 371 "../../gcc/config/s390/constraints.md"
(s390_contiguous_bitmask_p (ival, true, 64, NULL, NULL));

    case CONSTRAINT_NxxSq:
      return 
#line 376 "../../gcc/config/s390/constraints.md"
(s390_contiguous_bitmask_p (ival, false, 32, NULL, NULL));

    case CONSTRAINT_NxxSw:
      return 
#line 381 "../../gcc/config/s390/constraints.md"
(s390_contiguous_bitmask_p (ival, true, 32, NULL, NULL));

    case CONSTRAINT_Os:
      return 
#line 394 "../../gcc/config/s390/constraints.md"
(s390_O_constraint_str ('s', ival));

    case CONSTRAINT_Op:
      return 
#line 403 "../../gcc/config/s390/constraints.md"
(s390_O_constraint_str ('p', ival));

    case CONSTRAINT_On:
      return 
#line 412 "../../gcc/config/s390/constraints.md"
(s390_O_constraint_str ('n', ival));

    default: break;
    }
  return false;
}

